Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# AsyncTaskChain Class Reference

The AsyncTaskChain is a subset of the AsyncTaskManager. More...

Inheritance diagram for AsyncTaskChain:

List of all members.

## Public Member Functions
AsyncTaskCollection | getActiveTasks ()
| Returns the set of tasks that are active (and not sleeping) on the task chain, at the time of the call.
double | getFrameBudget ()
| Returns the maximum amount of time per frame the tasks on this chain are granted for execution.
bool | getFrameSync ()
| Returns the frame_sync flag.
double | getNextWakeTime ()
| Returns the scheduled time (on the manager's clock) of the next sleeping task, on any task chain, to awaken.
int | getNumRunningThreads ()
| Returns the number of threads that have been created and are actively running.
int | getNumTasks ()
| Returns the number of tasks that are currently active or sleeping within the task chain.
int | getNumThreads ()
| Returns the number of threads that will be servicing tasks for this chain.
AsyncTaskCollection | getSleepingTasks ()
| Returns the set of tasks that are sleeping (and not active) on the task chain, at the time of the call.
AsyncTaskCollection | getTasks ()
| Returns the set of tasks that are active or sleeping on the task chain, at the time of the call.
ThreadPriority | getThreadPriority ()
| Returns the priority associated with threads that serve this task chain.
bool | getTickClock ()
| Returns the tick_clock flag.
bool | getTimeslicePriority ()
| Returns the timeslice_priority flag.
bool | hasTask (AsyncTask task)
| Returns true if the indicated task has been added to this AsyncTaskChain, false otherwise.
bool | isStarted ()
| Returns true if the thread(s) have been started and are ready to service requests, false otherwise.
| output (ostream out)
| Outputs the Namable.
| poll ()
| Runs through all the tasks in the task list, once, if the task chain is running in single-threaded mode (no threads available).
| setFrameBudget (double frame_budget)
| Sets the maximum amount of time per frame the tasks on this chain are granted for execution.
| setFrameSync (bool frame_sync)
| Sets the frame_sync flag.
| setNumThreads (int num_threads)
| Changes the number of threads for this task chain.
| setThreadPriority (ThreadPriority priority)
| Changes the priority associated with threads that serve this task chain.
| setTickClock (bool tick_clock)
| Sets the tick_clock flag.
| setTimeslicePriority (bool timeslice_priority)
| Sets the timeslice_priority flag.
| startThreads ()
| Starts any requested threads to service the tasks on the queue.
| stopThreads ()
| Stops any threads that are currently running.
| waitForTasks ()
| Blocks until the task list is empty.
| write (ostream out, int indent_level)
| write (ostream out)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

The AsyncTaskChain is a subset of the AsyncTaskManager.

Each chain maintains a separate list of tasks, and will execute them with its own set of threads. Each chain may thereby operate independently of the other chains.

The AsyncTaskChain will spawn a specified number of threads (possibly 0) to serve the tasks. If there are no threads, you must call poll() from time to time to serve the tasks in the main thread. Normally this is done by calling AsyncTaskManager.poll().

Each task will run exactly once each epoch. Beyond that, the tasks' sort and priority values control the order in which they are run: tasks are run in increasing order by sort value, and within the same sort value, they are run roughly in decreasing order by priority value, with some exceptions for parallelism. Tasks with different sort values are never run in parallel together, but tasks with different priority values might be (if there is more than one thread).

## Member Function Documentation

AsyncTaskCollection getActiveTasks | ( |  | ) |

Returns the set of tasks that are active (and not sleeping) on the task chain, at the time of the call.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedReferenceCount.

double getFrameBudget | ( |  | ) |

Returns the maximum amount of time per frame the tasks on this chain are granted for execution.

See set_frame_budget().

bool getFrameSync | ( |  | ) |

Returns the frame_sync flag.

See set_frame_sync().

double getNextWakeTime | ( |  | ) |

Returns the scheduled time (on the manager's clock) of the next sleeping task, on any task chain, to awaken.

Returns -1 if there are no sleeping tasks.

int getNumRunningThreads | ( |  | ) |

Returns the number of threads that have been created and are actively running.

This will return 0 before the threads have been started; it will also return 0 if thread support is not available.

int getNumTasks | ( |  | ) |

Returns the number of tasks that are currently active or sleeping within the task chain.

int getNumThreads | ( |  | ) |

Returns the number of threads that will be servicing tasks for this chain.

Also see get_num_running_threads().

AsyncTaskCollection getSleepingTasks | ( |  | ) |

Returns the set of tasks that are sleeping (and not active) on the task chain, at the time of the call.

AsyncTaskCollection getTasks | ( |  | ) |

Returns the set of tasks that are active or sleeping on the task chain, at the time of the call.

ThreadPriority getThreadPriority | ( |  | ) |

Returns the priority associated with threads that serve this task chain.

bool getTickClock | ( |  | ) |

Returns the tick_clock flag.

See set_tick_clock().

bool getTimeslicePriority | ( |  | ) |

Returns the timeslice_priority flag.

This changes the interpretation of priority, and the number of times per epoch each task will run. See set_timeslice_priority().

bool hasTask | ( | AsyncTask | task | ) |

Returns true if the indicated task has been added to this AsyncTaskChain, false otherwise.

bool isStarted | ( |  | ) |

Returns true if the thread(s) have been started and are ready to service requests, false otherwise.

If this is false, the next call to add() or add_and_do() will automatically start the threads.

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

poll | ( |  | ) |

Runs through all the tasks in the task list, once, if the task chain is running in single-threaded mode (no threads available).

This method does nothing in threaded mode, so it may safely be called in either case.

Normally, you would not call this function directly; instead, call AsyncTaskManager.poll(), which polls all of the task chains in sequence.

setFrameBudget | ( | double | frame_budget | ) |

Sets the maximum amount of time per frame the tasks on this chain are granted for execution.

If this is less than zero, there is no limit; if it is >= 0, it represents a maximum amount of time (in seconds) that will be used to execute tasks. If this time is exceeded in any one frame, the task chain will stop executing tasks until the next frame, as defined by the TaskManager's clock.

setFrameSync | ( | bool | frame_sync | ) |

Sets the frame_sync flag.

When this flag is true, this task chain will be forced to sync with the TaskManager's clock. It will run no faster than one epoch per clock frame.

When this flag is false, the default, the task chain will finish all of its tasks and then immediately start from the first task again, regardless of the clock frame. When it is true, the task chain will finish all of its tasks and then wait for the clock to tick to the next frame before resuming the first task.

This only makes sense for threaded task chains. Non-threaded task chains are automatically synchronous.

setNumThreads | ( | int | num_threads | ) |

Changes the number of threads for this task chain.

This may require stopping the threads if they are already running.

setThreadPriority | ( | ThreadPriority | priority | ) |

Changes the priority associated with threads that serve this task chain.

This may require stopping the threads if they are already running.

setTickClock | ( | bool | tick_clock | ) |

Sets the tick_clock flag.

When this is true, get_clock()->tick() will be called automatically at each task epoch. This is false by default.

setTimeslicePriority | ( | bool | timeslice_priority | ) |

Sets the timeslice_priority flag.

This changes the interpretation of priority, and the number of times per epoch each task will run.

When this flag is true, some tasks might not run in any given epoch. Instead, tasks with priority higher than 1 will be given precedence, in proportion to the amount of time they have already used. This gives higher-priority tasks more runtime than lower-priority tasks. Each task gets the amount of time proportional to its priority value, so a task with priority 100 will get five times as much processing time as a task with priority 20. For these purposes, priority values less than 1 are deemed to be equal to 1.

When this flag is false (the default), all tasks are run exactly once each epoch, round-robin style. Priority is only used to determine which task runs first within tasks of the same sort value.

startThreads | ( |  | ) |

Starts any requested threads to service the tasks on the queue.

This is normally not necessary, since adding a task will start the threads automatically.

stopThreads | ( |  | ) |

Stops any threads that are currently running.

If any tasks are still pending and have not yet been picked up by a thread, they will not be serviced unless poll() or start_threads() is later called.

waitForTasks | ( |  | ) |

Blocks until the task list is empty.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties